pcl::SegmentDifferences< PointT > Class Template Reference
Module segmentation

SegmentDifferences obtains the difference between two spatially aligned point clouds and returns the difference between them for a maximum given distance threshold. More...

`#include <pcl/segmentation/segment_differences.h>`

Inheritance diagram for pcl::SegmentDifferences< PointT >:

## Public Types

typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef pcl::search::Search< PointT > | KdTree
typedef pcl::search::Search< PointT >::Ptr | KdTreePtr
typedef PointIndices::Ptr | PointIndicesPtr
typedef PointIndices::ConstPtr | PointIndicesConstPtr
Public Types inherited from pcl::PCLBase< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| SegmentDifferences ()
| Empty constructor. More...
void | setTargetCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the target dataset against which we compare the input cloud given in setInputCloud. More...
PointCloudConstPtr const | getTargetCloud ()
| Get a pointer to the input target point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod ()
| Get a pointer to the search method used. More...
void | setDistanceThreshold (double sqr_threshold)
| Set the maximum distance tolerance (squared) between corresponding points in the two input datasets. More...
double | getDistanceThreshold ()
| Get the squared distance tolerance between corresponding points as a measure in the L2 Euclidean space. More...
void | segment (PointCloud &output)
| Segment differences between two input point clouds. More...
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

virtual std::string | getClassName () const
| Class getName method. More...
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

KdTreePtr | tree_
| A pointer to the spatial search object. More...
PointCloudConstPtr | target_
| The input target point cloud dataset. More...
double | distance_threshold_
| The distance tolerance (squared) as a measure in the L2 Euclidean space between corresponding points. More...
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointT>
class pcl::SegmentDifferences< PointT >

SegmentDifferences obtains the difference between two spatially aligned point clouds and returns the difference between them for a maximum given distance threshold.

Author
  Radu Bogdan Rusu

Definition at line 72 of file segment_differences.h.

## Member Typedef Documentation

template<typename PointT >

typedef pcl::search::Search<PointT> pcl::SegmentDifferences< PointT >::KdTree

Definition at line 81 of file segment_differences.h.

template<typename PointT >

typedef pcl::search::Search<PointT>::Ptr pcl::SegmentDifferences< PointT >::KdTreePtr

Definition at line 82 of file segment_differences.h.

template<typename PointT >

typedef pcl::PointCloud<PointT> pcl::SegmentDifferences< PointT >::PointCloud

Definition at line 77 of file segment_differences.h.

template<typename PointT >

typedef PointCloud::ConstPtr pcl::SegmentDifferences< PointT >::PointCloudConstPtr

Definition at line 79 of file segment_differences.h.

template<typename PointT >

typedef PointCloud::Ptr pcl::SegmentDifferences< PointT >::PointCloudPtr

Definition at line 78 of file segment_differences.h.

template<typename PointT >

typedef PointIndices::ConstPtr pcl::SegmentDifferences< PointT >::PointIndicesConstPtr

Definition at line 85 of file segment_differences.h.

template<typename PointT >

typedef PointIndices::Ptr pcl::SegmentDifferences< PointT >::PointIndicesPtr

Definition at line 84 of file segment_differences.h.

## Constructor & Destructor Documentation

template<typename PointT >

pcl::SegmentDifferences< PointT >::SegmentDifferences | ( |  | ) |

inline

Empty constructor.

Definition at line 88 of file segment_differences.h.

## Member Function Documentation

template<typename PointT >

virtual std::string pcl::SegmentDifferences< PointT >::getClassName | ( |  | ) | const

inline protected virtual

Class getName method.

Definition at line 154 of file segment_differences.h.

template<typename PointT >

double pcl::SegmentDifferences< PointT >::getDistanceThreshold | ( |  | ) |

inline

Get the squared distance tolerance between corresponding points as a measure in the L2 Euclidean space.

Definition at line 126 of file segment_differences.h.

References pcl::PCLBase< PointT >::deinitCompute(), pcl::SegmentDifferences< PointT >::distance_threshold_, pcl::PCLBase< PointT >::indices_, pcl::PCLBase< PointT >::initCompute(), pcl::PCLBase< PointT >::input_, and pcl::SegmentDifferences< PointT >::segment().

template<typename PointT >

KdTreePtr pcl::SegmentDifferences< PointT >::getSearchMethod | ( |  | ) |

inline

Get a pointer to the search method used.

Definition at line 112 of file segment_differences.h.

References pcl::SegmentDifferences< PointT >::tree_.

template<typename PointT >

PointCloudConstPtr const pcl::SegmentDifferences< PointT >::getTargetCloud | ( |  | ) |

inline

Get a pointer to the input target point cloud dataset.

Definition at line 102 of file segment_differences.h.

References pcl::SegmentDifferences< PointT >::target_.

template<typename PointT >

void pcl::SegmentDifferences< PointT >::segment | ( | PointCloud & | output | ) |

Segment differences between two input point clouds.

Parameters

  output | the resultant difference between the two point clouds as a PointCloud

Definition at line 95 of file segment_differences.hpp.

References pcl::getPointCloudDifference(), pcl::PointCloud< PointT >::header, pcl::PointCloud< PointT >::height, pcl::PointCloud< PointT >::points, and pcl::PointCloud< PointT >::width.

Referenced by pcl::SegmentDifferences< PointT >::getDistanceThreshold().

template<typename PointT >

void pcl::SegmentDifferences< PointT >::setDistanceThreshold | ( | double | sqr_threshold | ) |

inline

Set the maximum distance tolerance (squared) between corresponding points in the two input datasets.

Parameters

  sqr_threshold | the squared distance tolerance as a measure in L2 Euclidean space

Definition at line 120 of file segment_differences.h.

References pcl::SegmentDifferences< PointT >::distance_threshold_.

template<typename PointT >

void pcl::SegmentDifferences< PointT >::setSearchMethod | ( | const KdTreePtr & | tree | ) |

inline

Provide a pointer to the search object.

Parameters

  tree | a pointer to the spatial search object.

Definition at line 108 of file segment_differences.h.

References pcl::SegmentDifferences< PointT >::tree_.

template<typename PointT >

void pcl::SegmentDifferences< PointT >::setTargetCloud | ( | const PointCloudConstPtr & | cloud | ) |

inline

Provide a pointer to the target dataset against which we compare the input cloud given in setInputCloud.

Parameters

  cloud | the target PointCloud dataset

Definition at line 98 of file segment_differences.h.

References pcl::SegmentDifferences< PointT >::target_.

## Member Data Documentation

template<typename PointT >

double pcl::SegmentDifferences< PointT >::distance_threshold_

protected

The distance tolerance (squared) as a measure in the L2 Euclidean space between corresponding points.

Definition at line 150 of file segment_differences.h.

Referenced by pcl::SegmentDifferences< PointT >::getDistanceThreshold(), and pcl::SegmentDifferences< PointT >::setDistanceThreshold().

template<typename PointT >

PointCloudConstPtr pcl::SegmentDifferences< PointT >::target_

protected

The input target point cloud dataset.

Definition at line 145 of file segment_differences.h.

Referenced by pcl::SegmentDifferences< PointT >::getTargetCloud(), and pcl::SegmentDifferences< PointT >::setTargetCloud().

template<typename PointT >

KdTreePtr pcl::SegmentDifferences< PointT >::tree_

protected

A pointer to the spatial search object.

Definition at line 142 of file segment_differences.h.

Referenced by pcl::SegmentDifferences< PointT >::getSearchMethod(), and pcl::SegmentDifferences< PointT >::setSearchMethod().

The documentation for this class was generated from the following files:

- /build/pcl-0nnAvv/pcl-1.7.2/segmentation/include/pcl/segmentation/segment_differences.h
- /build/pcl-0nnAvv/pcl-1.7.2/segmentation/include/pcl/segmentation/impl/segment_differences.hpp